public class FlatSortedList implements SortedList {
	private FlatSortedListItem root = null;
	
	public FlatSortedList() {}

	public void insert(ListItem item) {
		FlatSortedListItem newItem = new FlatSortedListItem(item.getValue());
		if (root == null) {
			// insert newItem as first/only element
			root = newItem;
			return;
		}
		if (root.getValue() > newItem.getValue()) {
			// insert newItem as new first element
			newItem.next = root;
			root = newItem;
			return;
		}
		FlatSortedListItem current = root.next;
		FlatSortedListItem prev = root;
		while ((current.next != null) && (current.getValue() < newItem.getValue())) {
			prev = current;
			current = current.next;
		}
		if ((current.next == null) && (current.getValue() < newItem.getValue())) {
			newItem.next = null;
			current.next = newItem;
			return;
		}
		newItem.next = current;
		prev.next = newItem;
	}

	public SortedListIterator getIterator() {
		return new FlatSortedListIterator(root);
	}
}