public class TreeSortedListIterator implements SortedListIterator {
	private TreeSortedListItem current = null;
	private boolean firstItem = false;

	public TreeSortedListIterator(TreeSortedListItem root) {
		current = root;
		while (current.leftChild != null) {
			current = current.leftChild;
		}
		firstItem = true;
	}

	public ListItem nextItem() {
		if (firstItem) {
			firstItem = false;
			return current;
		}
		if (current.rightChild != null) {
			current = current.rightChild;
			while(current.leftChild != null) {
				current = current.leftChild;
			}
			return current;
		}
		TreeSortedListItem oldCurrent = current;
		current = current.parent;

		// check if we went up from a right child
		// (if so, we want to go up another level)
		while ((current != null) && (current.rightChild == oldCurrent)) {
			oldCurrent = current;
			current = current.parent;
		}

		return current;
	}

	public String toString() {
		TreeSortedListItem oldCurrent = current;
		String s = new String("{");
		boolean first = true;
		ListItem cur = null;
		while ((cur = nextItem()) != null) {
			if (first) {
				first = false;
			} else {
				s += ", ";
			}
			s += ""+cur.getValue();
		}
		s += "}";
		current = oldCurrent;
		return s;
	}
}