import java.util.ArrayList;

public class AccountService {
	private ArrayList<Transaction> transactions = null;
	private ArrayList<Account> accounts = null;
   
	public AccountService() {
		transactions = new ArrayList<Transaction>();
		accounts = new ArrayList<Account>();
	}
	
	public void deposit(int accountId, float amount) throws NoSuchAccountException {
		Account account = getAccount(accountId);
		
		if (account == null)
			throw new NoSuchAccountException("No such account: "+accountId);
		
		account.setBalance(account.getBalance() + amount);
		
		transactions.add(new Transaction(accountId, amount, "Deposit"));
	}
	
	public void withdraw(int accountId, float amount) throws NoSuchAccountException, InsufficientFundsException {
		Account account = getAccount(accountId);
		
		if (account == null)
			throw new NoSuchAccountException("No such account: "+accountId);

		if (account.getBalance() < amount)
			throw new InsufficientFundsException("Account #"+accountId+"'s balance of $"+account.getBalance()+" is insufficient for a withdrawal of $"+amount+".");

		account.setBalance(account.getBalance() - amount);
		
		transactions.add(new Transaction(accountId, amount, "Withdrawal"));
	}
	
	public Account getAccount(int accountId) {
		/*
		if (accounts.size() > 0)
			return accounts.get(0);
			
		return null;
		*/
//		/*
		for (int i = 0; i < accounts.size(); i++) {
			if (accounts.get(i).getAccountId() == accountId)
				return accounts.get(i);
		}
		return null;
//		*/
	}
	
	public void addAccount(Account newAccount) {
		accounts.add(newAccount);
	}
}